addEventListener('load',alkulataus,false);
var ajastinID;
var iFrame = 0;
var efekti;
var eScene;

// Useful things
const pi2 = 2 * Math.PI;

// Running order / kuvakäsikirjoitus
var timing; // Defined at alkulataus
var curEffects = new Object(); // Used as a hash table for current effects

function alkulataus() {
	eScene = document.getElementById('scene');
	
	// Running order. Limitation: Only one event per tick is allowed.
	timing = {

		0:    { effect: efFillpac, end: 120   },
		200:  { effect: efPalkki,  end: 700   },
		120:  { effect: efJames,   end: 500   },
		600:  { effect: efZoom,    end: 699   },
		700:  { effect: efPallerot,end: 1200  },

		1000:  { effect: efSelitys, end: 2000 },

/*		0:    { effect: efPalkki,  end: 800   },*/
		2000: { effect: efNoOp,    end: null  }
	}
	
	// Effects have to be initialized after DOM is ready (=now), not at script load time
	for ( var i in timing ) {
		timing[i].effect.init();
	}
	
	// Start the machine when everything is ready
	ajastinID = window.setInterval(tick,40);
}

function tick() {
	
	var beginEffect = timing[iFrame];
	if (beginEffect) {
		curEffects[iFrame] = beginEffect;
		beginEffect.effect.begin(); // Start the effect
	}
	
	for ( var i in curEffects ) {
		
		if ( curEffects[i].end == iFrame ) {
			curEffects[i].effect.end();
			// Keep only running elements in the object table
			delete(curEffects[i]);
		} else {
			curEffects[i].effect.draw();
		}
	}

	iFrame++;
}

var efNoOp = new Object();
efNoOp.init = function () {
}
efNoOp.begin = function () {
	// Hupi loppuu tähän!
	window.clearTimeout(ajastinID);
	//alert("Loppu!");
}
efNoOp.end = function () {
}
efNoOp.draw = function () {
	// Called once
}
